class CardTreeNode(object):
    
    def __init__(self, card, parent_node = None):
        self.card = card
        self.parent = parent_node
        if self.parent:
            self.depth = parent_node.depth + 1
        else:
            self.depth = 0
        
    def clear(self):
        self.card = None
        self.parent = None
    
    #Test if node is ancestor of self
    def test_ancestor(self, node):
#        print 'Ancestor search: ' + str(self) + ' -- ' + str(node)
#        print 'Parent: ' + str(self.parent)
        if self.parent == node:
#            print 'Return true'
            return True
        elif self.parent == None:
#            print 'Return false'
            return False
        else:
            return self.parent.test_ancestor(node)

    def __cmp__(self, other):
        if isinstance(self, CardTreeNode) and isinstance(other, CardTreeNode): 
            if self.card == other.card:
                if self.parent == None:
                    if other.parent == None:
#                        print 'both parents none'
                        return 0
                    else:
#                        print 'self parent none'
                        return -1
                elif other.parent == None:
#                    print 'other parent none'
                    return -1
                elif self.parent.card == other.parent.card:
#                    print 'parents match'
                    return 0
                else:
#                    print 'none of above 1'
                    return -1
            else:
#                print 'none of above 2'
                return -1
        else:
#            print 'none of above 3'
            return -1

    def __repr__(self):
        return str(self.card)        
        
class CardTree(object):
    
    def __init__(self, root_node):
        self.node_list = []        
        self.root = root_node
        self.insert_node(self.root)
        
    def insert_node(self, node, parent_node = None):
        self.node_list.append(node)    
        return node
        
    def insert_card(self, card, parent_node = None):
        new_node = CardTreeNode(card, parent_node)
        self.nodes.append(new_node)
        return new_node
    
    def remove(self, node):
        node.clear()
        self.node_list.remove(node)
        
    def __repr__(self):
        return str(self.node_list)