#Base class
#----------------------------------------------------------------------
class Event:
    
    #This is a superclass for any events that might be generated by an
    #object and sent to the EventManager
    def __init__(self):
        self.name = "Generic Event"

#General events
#----------------------------------------------------------------------
class TickEvent(Event):
    
    def __init__(self):
        self.name = "CPU Tick Event"
        
class SecondEvent(Event):
    def __init__(self):
        self.name = "Clock One Second Event"        
 
class QuitEvent(Event):
    
    def __init__(self):
        self.name = "Program Quit Event"
 
class MouseButtonLeftEvent(Event):
    
    def __init__(self, pos):
        self.name = "Mouse Button Event"
        self.pos = pos

class MouseMoveEvent(Event):
    
    def __init__(self, pos):    
        self.name = "Mouse Moved Event"
        self.pos = pos     

#Widget events
#----------------------------------------------------------------------
class GUIFocusThisWidgetEvent(Event):

    def __init__(self, widget):
        self.name = "Activate particular widget Event"
        self.widget = widget
        
class GUIUnfocusThisWidgetEvent(Event):

    def __init__(self, widget):
        self.name = "Activate particular widget Event"
        self.widget = widget        
        
#Game specific events
#----------------------------------------------------------------------    
class DealNewBoardRequest(Event):
    
    def __init__(self, deck, board):    
        self.name = "New board request"  
        self.deck = deck
        self.board = board
    